************************************************************
* INTSERV.ASM:   Interrupt-Server-Routine   fr   Atari-ST *
* Dieser Interruptserver  kann  ber  XBIOS-31 fr Timer A *
* installiert werden.  Er  liest  dann einen Datensatz von *
* einem Sampler am ROM-Port, wenn COUNT zurckgesetzt wird.*
************************************************************

SAMPLE: MOVEM.L D4-D5/A6,-(A7)      * Register retten
        MOVE.B  $FA0001,D4          * AD-Wandler lesen
        MOVE.W  COUNT(PC),D5        * Zhler laden
        CMP.W   UNTIL(PC),D5        * Schon am Ende ?
        BEQ     EXIT                * Dann raus !
        LEA     DATA(PC),A6         * Tabellenadresse laden
        MOVE.B  D4,0(A6,D5.W)       * Wert in Tabelle legen
        ADDQ.W  #1,D5               * sonst hochzhlen
        LEA     COUNT(PC),A6        * Adresse von Count
        MOVE.W  D5,(A6)             * Zhler sichern 
EXIT:   MOVEM.L (A7)+,D4-D5/A6      * Register zurckladen
        ANDI.B  #%11011111,$FFFA0F  * Interrupts freigeben
        RTE                         * Ab nach Hause
COUNT:  .DC.W   4096                * Zeiger auf Daten
UNTIL:  .DC.W   4096                * Ende des Datenfeldes
DATA:   .DS.B   4096
        .END

************************************************************
*                 Ende von INTSERV.ASM                     *
